addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.anglestand
				if not (player.cmd.forwardmove and player.cmd.sidemove)
				and P_IsPlayerOnGround(player)
				and (player.panim & PA_IDLE)
				and player.truedrawangle ~= nil
				and P_IsPlayerManiafied(player)
					player.drawangle = player.truedrawangle
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if not P_IsPlayerManiafied(player) return end
		if player.momentum
			if (player.speed >= skins[player.mo.skin].runspeed
			or player.powers[pw_underwater])
			and (player.cmd.forwardmove or player.cmd.sidemove)
				player.mo.friction = FRACUNIT
				player.charflags = $ & ~SF_NOSKID
			else
				player.mo.friction = 29*FRACUNIT/32
				player.charflags = $ & ~SF_NOSKID
			end
		end
		if player.truedrawangle == nil
			player.truedrawangle = player.drawangle
		end
		if player.cmd.forwardmove 
		or player.cmd.sidemove
			player.truedrawangle = player.drawangle
		end
		if not P_IsPlayerOnGround(player)
			player.truedrawangle = player.drawangle
		end
		if player.panim ~= PA_IDLE
			player.truedrawangle = player.drawangle
		end
		if player.sprung == nil
			player.sprung = false
		end
		if P_IsPlayerOnGround(player)
		and not (player.mo.eflags & MFE_SPRUNG)
			player.sprung = false
		elseif (player.mo.eflags & MFE_SPRUNG)
		and not P_IsPlayerOnGround(player)
			player.sprung = true
		end
		if player.sprung
		and player.panim ~= PA_SPRING
			player.sprung = false
		end
		if player.airwalk
			if player.mo.momz == 0
			and player.sprung
				player.mo.state = S_PLAY_WALK
			end
		end
		if player.fallback
			if player.speed >= skins[player.mo.skin].runspeed*3
				player.camerascale = $ + FRACUNIT/100
			elseif player.speed < skins[player.mo.skin].runspeed*3
			and player.camerascale > FRACUNIT
				player.camerascale = $ - FRACUNIT/15
			end
		else
			player.camerascale = FRACUNIT
		end
		if player.prevspringx == nil
			player.prevspringx = player.mo.x
		end
		if player.prevspringy == nil
			player.prevspringy = player.mo.y
		end
		if not (player.mo.eflags & MFE_SPRUNG)
			player.prevspringx = player.mo.x
			player.prevspringy = player.mo.y
		end
		if player.shoes
			if player.powers[pw_sneakers]
			and leveltime%2 == 0
				M_SpawnGhost(player)
			end
		end
		if player.prevz == nil
			player.prevz = player.mo.z
		end
		if leveltime%2 == 0
			player.prevz = player.mo.z
		end
		if player.classic
			if player.mo.standingslope
			and player.mo.z < player.prevz
			and (player.cmd.forwardmove or player.cmd.sidemove)
				if (player.pflags & PF_SPINNING)
					P_Thrust(player.mo, player.drawangle, 5*FRACUNIT/2)
				else
					P_Thrust(player.mo, player.drawangle, FRACUNIT)
				end
			end
			if player.mo.standingslope
			and player.mo.z > player.prevz
				if player.speed >= player.normalspeed
					if (player.pflags & PF_SPINNING)
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT)
					else
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT/4)
					end
				else
					if (player.pflags & PF_SPINNING)
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT/4)
					else
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT/8)
					end
				end
			end
		end
		if player.solidspring == nil
			player.solidspring = false
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.cd continue end
			if player.redrawangle == nil
				player.redrawangle = player.mo.angle
			end
			if player.shouldrotate == nil
				player.shouldrotate = false
			end
			if player.springtype == nil
				player.springtype = "none"
			end
			if (player.mo.eflags & MFE_SPRUNG)
				player.sprung = true
			end
			if player.sprung
			and player.shouldrotate
			and player.springtype == "verti"
			and player.mo.momz > 0*FRACUNIT
				player.drawangle = player.redrawangle
				player.redrawangle = $ + FixedAngle(21*FRACUNIT)
			end
			if not player.sprung
				player.shouldrotate = false
				player.springtype = "none"
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid
		if P_IsPlayerManiafied(player)
			player.truedrawangle = player.drawangle
		end
	end
end)

addHook("MobjCollide", function(touched, toucher)
	if touched and touched.valid
	and toucher and toucher.valid
	and toucher.player and toucher.player.valid
	and M_SpringType(touched) == "verti"
		local player = toucher.player
		if not P_IsPlayerManiafied(player) return end
		if not toucher.player.solidspring
			if not player.sp return end
			if toucher.z - toucher.momz > (touched.height/2) + touched.z then return end
			if touched.z > toucher.height + toucher.z - toucher.momz then return end
			player.solidspring = true
			P_SetOrigin(toucher, player.prevspringx, player.prevspringy, player.mo.z)
			player.powers[pw_pushing] = $ + 1
			if P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				player.mo.momx = 0
				player.mo.momy = 0
			end
			player.solidspring = false
			return true
		end
	end
	if touched and touched.valid
	and toucher and toucher.valid
	and toucher.player and toucher.player.valid
	and M_SpringType(touched) == "verti"
		local player = toucher.player
		player.shouldrotate = true
		player.springtype = "verti"
		return false
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.classic continue end
			if (player.pflags & PF_SPINNING)
			and not P_IsPlayerOnGround(player)
				player.pflags = $ & ~PF_SPINNING
			end
			if player.jumptics == 1
			and (player.pflags & PF_SPINNING)
			and not player.mo.standingslope
				if player.speed > skins[player.mo.skin].normalspeed
					if player.speed >= skins[player.mo.skin].normalspeed/2
						P_Thrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed - skins[player.mo.skin].normalspeed*2)/5)
					end
				end
			end
			if player.jumptics == 1
			and player.mo.standingslope
				if player.mo.z < player.prevz
					if (player.pflags & PF_SPINNING)
						P_InstaThrust(player.mo, player.drawangle, (player.speed + 10*FRACUNIT))
					else
						P_InstaThrust(player.mo, player.drawangle, (player.speed + 5*FRACUNIT))
					end
				elseif player.mo.z > player.prevz
				and player.mo.standingslope.zangle > ANGLE_MAX
					if player.cmd.forwardmove < 0
						P_SetObjectMomZ(player.mo, (10*FRACUNIT * player.jumpfactor)*10, false)
						P_InstaThrust(player.mo, (player.drawangle + ANGLE_180), player.speed)
					end
				end
			end
			if ((player.cmd.buttons & BT_USE) or player.dropdash)
			and (player.mo.eflags & MFE_JUSTHITFLOOR)
			and player.mo.standingslope
				if (player.cmd.buttons & BT_USE)
					P_Thrust(player.mo, player.drawangle, (AngleFixed(player.mo.standingslope.zangle))/20)
				else
					P_Thrust(player.mo, player.drawangle, (AngleFixed(player.mo.standingslope.zangle))/4)
				end
			end
		end
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.reroll return end
	if not P_IsPlayerOnGround(player)
	and not player.crouch
	and not player.fakespin
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_JUMPED)
	and not P_PlayerInPain(player)
	and not player.powers[pw_carry]
	and (player.mo.state ~= S_PLAY_FLY
	and player.mo.state ~= S_PLAY_SWIM
	and player.mo.state ~= S_PLAY_FLY_TIRED)
	and player.panim ~= PA_ABILITY
	and player.panim ~= PA_ABILITY2
	and not player.secondjump
		player.sprung = false
		player.mo.state = S_PLAY_ROLL
		player.drawangle = player.mo.angle
		S_StartSound(player.mo, sfx_spin)
		player.pflags = $|PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if not P_IsPlayerManiafied(player) return end
		if not player.crouching return end
		if player.crouch == nil
			player.crouch = false
		end
		if player.fakespin == nil
			player.fakespin = false
		end
		if player.fakespincharge == nil
			player.fakespincharge = 0
		end
		if player.fakespincharge > 65*FRACUNIT
			player.fakespincharge = 65*FRACUNIT
		end
		if player.fakespincharge > 0
			player.fakespincharge = $ - FRACUNIT/2
		end
		if player.fakespincharge < 20*FRACUNIT
			player.fakespincharge = 20*FRACUNIT
		end
		if player.crouch or player.fakespin
			player.pflags = $|PF_FULLSTASIS
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			if player.fakespin
				P_SpawnSkidDust(player, 10*FRACUNIT)
				coollookindust(player)
				player.drawangle = player.mo.angle
			end
			if not (player.cmd.buttons & BT_USE)
			and player.crouch
			and not player.fakespin
				player.crouch = false
				player.mo.state = S_PLAY_CROUCH_END
			end
			if (P_PlayerInPain(player)
			or player.powers[pw_carry])
				player.fakespin = false
				player.crouch = false
			end
		end
		if player.fakespin
		and not (player.cmd.buttons & BT_USE)
			player.fakespin = false
			player.crouch = false
			player.pflags = $ & ~PF_FULLSTASIS
			if not player.powers[pw_sneakers]
				if not player.powers[pw_underwater]
					if not player.powers[pw_super]
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge)
					else
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge + 30*FRACUNIT)
					end
				else
					if not player.powers[pw_super]
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge/2)
					else
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge)
					end
				end
			else
				if not player.powers[pw_underwater]
					if not player.powers[pw_super]
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge + 30*FRACUNIT)
					else
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge + 60*FRACUNIT)
					end
				else
					if not player.powers[pw_super]
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge)
					else
						P_InstaThrust(player.mo, player.mo.angle, player.fakespincharge + 30*FRACUNIT)
					end
				end
			end
			player.fakespincharge = 0*FRACUNIT
			player.pflags = $|PF_SPINNING
			player.mo.state = S_PLAY_ROLL
			S_StartSound(player.mo, sfx_zoom)
		end
		if player.fakespin
		and player.jumptics ~= 1
			player.fakespincharge = $ - FRACUNIT/4
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.fakespin
		return true
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.crouching return end
	if (P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR) or player.rollout and (player.powers[pw_carry] & CR_ROLLOUT))
	and player.mo.momz == 0
	and player.speed < 9*FRACUNIT
	and (player.charability2 & CA2_SPINDASH)
	and not player.sprung
		player.crouch = true
		player.pflags = $|PF_FULLSTASIS
		return true
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.crouching continue end
			if (P_IsPlayerOnGround(player) or player.rollout and player.crouching)
			and player.crouch
			and player.jumptics == 1
				player.fakespin = true
				player.crouch = false
				S_StartSound(player.mo, sfx_spndsh)
				player.mo.state = S_PLAY_SPINDASH
				player.fakespincharge = 20*FRACUNIT
			elseif player.fakespin == true
			and (P_IsPlayerOnGround(player) or player.rollout and player.crouching)
			and player.jumptics == 1
				player.fakespincharge = $ + 10*FRACUNIT
				S_StartSound(player.mo, sfx_spndsh)
				player.mo.state = S_PLAY_SPINDASH
			end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.peelout continue end
			if player.peelouting == nil
				player.peelouting = false
			end
			if player.peeloutstrength == nil
				player.peeloutstrength = 0
			end
			if (player.cmd.buttons & BT_CUSTOM1)
			and P_IsPlayerOnGround(player)
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
			and not player.crouch
			and not player.fakespin
			and not (player.pflags & PF_FULLSTASIS)
			and not (player.pflags & PF_STASIS)
			and player.speed < 9*FRACUNIT
				if not player.peelouting
					S_StartSound(player.mo, sfx_spndsh)
				end
				player.peelouting = true
				if not player.powers[pw_sneakers]
					if not player.powers[pw_super]
						player.peeloutstrength = $ + FRACUNIT
					else
						player.peeloutstrength = $ + 2*FRACUNIT
					end
				else
					if not player.powers[pw_super]
						player.peeloutstrength = $ + 2*FRACUNIT
					else
						player.peeloutstrength = $ + 4*FRACUNIT
					end
				end
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
			and player.peelouting
			and not (player.crouch or player.fakespin)
				if not player.powers[pw_sneakers]
					if not player.powers[pw_underwater]
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					else
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength/2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, (player.peeloutstrength))
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					end
				else
					if not player.powers[pw_underwater]
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*4)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					else
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					end
				end
				player.peelouting = false
				player.pflags = $ & ~PF_JUMPSTASIS
				S_StartSound(player.mo, sfx_zoom)
				player.peeloutstrength = 0
			end
			if ((P_PlayerInPain(player)
			or player.powers[pw_carry]
			or player.crouch
			or player.fakespin
			or (player.pflags & PF_FULLSTASIS)
			or (player.pflags & PF_STASIS)))
			and player.peelouting
				player.peelouting = false
				player.pflags = $ & ~PF_JUMPSTASIS
				player.peeloutstrength = 0
			end
			if player.peelouting
				player.mo.momx = 0
				player.mo.momy = 0
				player.pflags = $|PF_FULLSTASIS
				player.drawangle = player.mo.angle
				coollookindust(player)
				if player.peeloutstrength < skins[player.mo.skin].runspeed
					player.mo.state = S_PLAY_PEELOUT_WALK
				elseif player.peeloutstrength >= skins[player.mo.skin].runspeed
				and player.peeloutstrength < 60*FRACUNIT
					player.mo.state = S_PLAY_PEELOUT_RUN
				elseif player.peeloutstrength >= 60*FRACUNIT
				and player.peeloutanim
					player.mo.state = S_PLAY_DASH
				elseif player.peeloutstrength >= 60*FRACUNIT
				and not player.peeloutanim
					player.mo.state = S_PLAY_PEELOUT_RUN
				end
				if player.peeloutstrength > 70*FRACUNIT
					player.peeloutstrength = 70*FRACUNIT
				end
			end
		end
	end
end)

//Insta Shield

addHook("PlayerThink", function(player)
	if player.instashield == nil
		player.instashield = 0
	end
	if player.instashield > 0
		player.instashield = $ - 1
	end
end)

addHook("AbilitySpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.insta return end
	if player.instas return end
	if player.mo and player.mo.valid
	and (player.cmd.buttons & BT_JUMP)
	and not P_IsPlayerOnGround(player)
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
	and not player.powers[pw_super]
	and not (player.powers[pw_shield] & SH_NOSTACK)
		local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INSTASHIELD)
		instashield.radius = player.mo.radius*2
		instashield.height = player.mo.height*2
		instashield.scale = player.mo.scale*3/2
		instashield.target = player.mo
		player.pflags = $|PF_THOKKED
		S_StartSound(player.mo, sfx_s3k42)
		player.powers[pw_flashing] = 8
		player.instashield = 8
		return false
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.insta return end
	if not player.instas return end
	if player.mo and player.mo.valid
	and (player.cmd.buttons & BT_USE)
	and not P_IsPlayerOnGround(player)
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
	and not player.powers[pw_super]
	and not (player.powers[pw_shield] & SH_NOSTACK)
		local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INSTASHIELD)
		instashield.radius = player.mo.radius*2
		instashield.height = player.mo.height*2
		instashield.scale = player.mo.scale*3/2
		instashield.target = player.mo
		player.pflags = $|PF_THOKKED
		S_StartSound(player.mo, sfx_s3k42)
		player.powers[pw_flashing] = 8
		player.instashield = 8
		return false
	end
end)

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
	and mobj.target and mobj.target.valid
		local player = mobj.target.player
		P_SetOrigin(mobj, player.mo.x, player.mo.y, player.mo.z)
		mobj.angle = player.drawangle
	end
end, MT_INSTASHIELD)

addHook("MobjCollide", function(touched, toucher)
	if touched and touched.valid
	and toucher and toucher.valid
	and toucher.target and toucher.target.valid
	and toucher.target.player
		local player = toucher.target
		P_DamageMobj(touched, toucher, toucher.target, 1)
		if player.instar
			player.mo.momx = -$
			player.mo.momy = -$
			player.mo.momz = -$
		end
	end
end, MT_INSTASHIELD)

addHook("ShouldDamage", function(target, inflictor)
	if target and target.valid
	and inflictor and inflictor.valid
	and target.player and target.player.valid
	and (inflictor.flags & MF_MISSILE)
	and target.player.instashield
		local player = target.player
		inflictor.momx = -$
		inflictor.momy = -$
		inflictor.momz = -$
		inflictor.target = target
		return false
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.rollafteruse continue end
			if (player.pflags & PF_THOKKED)
			and player.mo.momz < -5*FRACUNIT
			and player.candropdash
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.timeout ~= true continue end
			if player.realtime/TICRATE >= 600
			and player.playerstate == PST_LIVE
				P_KillMobj(player.mo)
			end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.cdtimeout ~= true continue end
			if player.cdtimeouttimer == nil
				player.cdtimeouttimer = 0
			end
			if player.speed == 0*FRACUNIT
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and P_IsPlayerOnGround(player)
				player.cdtimeouttimer = $ + 1
			else
				player.cdtimeouttimer = 0
			end
			if player.cdtimeouttimer/TICRATE >= 180
			and player.playerstate == PST_LIVE
				P_KillMobj(player.mo)
				player.mo.flags = $ & ~MF_NOGRAVITY
				player.mo.flags = $|MF_NOCLIP
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				P_InstaThrust(player.mo, player.mo.angle + ANGLE_270, 30*FRACUNIT)
				P_SetObjectMomZ(player.mo, 30*FRACUNIT, false)
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)

// K Me time

addHook("PlayerThink", function(player)
	if player.onwall == nil
		player.onwall = false
	end
	if player.prevspeed == nil
		player.prevspeed = 0
	end
	if player.ceilingrun == nil
		player.ceilingrun = false
	end
	if player.prevmomz == nil
		player.prevmomz = 0
	end
	if player.prevslope == nil
		player.prevslope = player.mo.standingslope
	end
	if player.wallline == nil
		player.wallline = 0
	end
	if player.wx == nil
		player.wx = 0
	end
	if player.wy == nil
		player.wy = 0
	end
	if player.w == nil
		player.w = 0
	end
	if player.falltime == nil
		player.falltime = 0
	end
	if player.wasonwall == nil
		player.wasonwall = false
	end
	if player.wallspin == nil
		player.wallspin = false
	end
	if player.mo.standingslope
		player.prevslope = player.mo.standingslope
	end
	if player.onwall
		player.mo.angle = GetFloorSlopeXY(player.mo) + FixedAngle((-player.cmd.sidemove)*FRACUNIT)
		player.mo.rollangle = FixedAngle((-player.cmd.sidemove)*FRACUNIT)
		if not (player.pflags & PF_SPINNING)
			P_InstaThrust(player.mo, player.wallline + ANGLE_270, (player.cmd.sidemove*FRACUNIT)/5)
		else
			P_InstaThrust(player.mo, player.wallline + ANGLE_270, (player.cmd.sidemove*FRACUNIT)/10)
		end
		if player.cmd.forwardmove > 0
			P_SetObjectMomZ(player.mo, FRACUNIT/3, true)
		else
			P_SetObjectMomZ(player.mo, FRACUNIT/4, true)
		end
		if leveltime%5 == 0
			player.prevmomz = player.mo.momz
		end
		if player.mo.momz < 1*FRACUNIT
		and player.mo.momz > -1*FRACUNIT
			player.onwall = false
			player.mo.rollangle = 0
		end
		if player.sprung
		or (player.mo.eflags & MFE_SPRUNG)
			player.onwall = false
		end
		if P_PointOnLineSide(player.mo.x, player.mo.y, player.w) == 0
			if player.w.backsector and player.w.backsector.valid
				if (player.mo.z + player.mo.height) >= player.w.backsector.floorheight
					player.onwall = false
					player.mo.rollangle = 0
					P_InstaThrust(player.mo, player.drawangle, 0*FRACUNIT)
				end
			else
				if (player.mo.z + player.mo.height) >= player.w.frontsector.floorheight
					player.onwall = false
					player.mo.rollangle = 0
					P_InstaThrust(player.mo, player.drawangle, 0*FRACUNIT)
				end
			end
		else
			if (player.mo.z + player.mo.height) >= player.w.frontsector.floorheight
				player.onwall = false
				player.mo.rollangle = 0
				P_InstaThrust(player.mo, player.drawangle, 0*FRACUNIT)
			end
		end
		if player.mo.z + player.mo.height >= player.mo.ceilingz
		and not player.ceilingrun
			player.mo.angle = GetFloorSlopeXY(player.mo) + ANGLE_180
			player.drawangle = GetFloorSlopeXY(player.mo) + ANGLE_180
			P_InstaThrust(player.mo, player.mo.angle, player.prevmomz*2)
			if (player.mo.flags2 & MF2_OBJECTFLIP)
				player.mo.flags2 = $ & ~MF2_OBJECTFLIP
			else
				player.mo.flags2 = $|MF2_OBJECTFLIP
			end
			player.ceilingrun = true
			player.onwall = false
			player.mo.rollangle = 0
		end
		if player.jumptics == 1
			P_InstaThrust(player.mo, player.wallline + ANGLE_180, 10*FRACUNIT)
			player.pflags = $|PF_JUMPED
			player.pflags = $ & ~PF_THOKKED
			S_StartSound(player.mo, sfx_jump)
			player.mo.rollangle = 0
			player.mo.state = S_PLAY_JUMP
			player.onwall = false
		end
		if (player.pflags & PF_SPINNING)
			player.wallspin = true
		end
	end
	if player.ceilingrun
		if leveltime%5 == 0
			player.prevspeed = player.speed
		end
		if player.speed < player.runspeed
		or not P_IsObjectOnGround(player.mo)
			player.falltime = $1+1
		end
		if player.falltime >= 36
			player.ceilingrun = false
			if (player.mo.flags2 & MF2_OBJECTFLIP)
				player.mo.flags2 = $ & ~MF2_OBJECTFLIP
			else
				player.mo.flags2 = $|MF2_OBJECTFLIP
			end
			player.mo.state = S_PLAY_FALL
			if P_IsObjectOnGround(player.mo)
				S_StartSound(player.mo, sfx_s3k51)
			end
			player.mo.rollangle = 0
			player.falltime = 0
		end
		if player.jumptics == 1
			player.ceilingrun = false
			player.frontiersboost = false
			if (player.mo.flags2 & MF2_OBJECTFLIP)
				player.mo.flags2 = $ & ~MF2_OBJECTFLIP
			else
				player.mo.flags2 = $|MF2_OBJECTFLIP
			end
		end
		if player.wallspin
		and P_IsPlayerOnGround(player)
			player.pflags = $|PF_SPINNING
			player.mo.state = S_PLAY_ROLL
			player.wallspin = false
		end
	else
		player.falltime = 0
	end
	//print ("Previous MomZ: " + (player.prevmomz))
	//print ("Previous Speed: " + (player.prevspeed))
	//print ("On Wall: " + (player.onwall))
	//print ("On Ceiling: " + (player.ceilingrun))
	//print ("Player Z: " + (player.mo.z/FRACUNIT))
	/*if player.w and player.w.valid
		if P_PointOnLineSide(player.mo.x, player.mo.y, player.w) == 0
			print ("Player's Wallrun Z: " + (player.w.backsector.floorheight/FRACUNIT))
		else
			print ("Player's Wallrun Z: " + (player.w.frontsector.floorheight/FRACUNIT))
		end
	end*/
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.onwall
			if player.cmd.forwardmove < 0
			and not (twodlevel or (player.mo.flags2 & MF2_TWOD))
				player.cmd.forwardmove = 0
			end
		end
	end
end)

addHook("MobjMoveBlocked", function(mo, mobj, line)
	if mo and mo.valid
	and line and line.valid
	and not (mobj and mobj.valid)
	and mo.player and mo.player.valid
	and P_IsPlayerManiafied(mo.player)
		local player = mo.player
		if not player.onwall
			if not player.ceilingrun
			and player.mo.standingslope
				player.onwall = true
				P_SetObjectMomZ(player.mo, player.prevspeed/2, false)
				player.wallline = GetWallAngle(mo, line)
				player.wx, player.wy = P_ClosestPointOnLine(player.mo.x, player.mo.y, line)
				player.w = line
			elseif player.ceilingrun
			and player.mo.standingslope
				player.ceilingrun = false
				player.mo.angle = GetFloorSlopeXY(player.mo) + ANGLE_180
				player.drawangle = GetFloorSlopeXY(player.mo) + ANGLE_180
				if (player.mo.flags2 & MF2_OBJECTFLIP)
					player.mo.flags2 = $ & ~MF2_OBJECTFLIP
				else
					player.mo.flags2 = $|MF2_OBJECTFLIP
				end
				P_SetObjectMomZ(player.mo, player.prevspeed/2, false)
				player.wallline = GetWallAngle(mo, line)
				player.wx, player.wy = P_ClosestPointOnLine(player.mo.x, player.mo.y, line)
				player.wasonwall = true
			end
		end
	end
end, MT_PLAYER)

// Peelout Handling and Water Running

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.powers[pw_underwater]
			and not player.powers[pw_super]
			and FixedRound(player.speed) >= 60*FRACUNIT
			or not player.powers[pw_underwater]
			and player.powers[pw_super]
			and FixedRound(player.speed) >= 90*FRACUNIT
			or player.powers[pw_underwater]
			and not player.powers[pw_super]
			and FixedRound(player.speed) >= 30*FRACUNIT
			or player.powers[pw_underwater]
			and player.powers[pw_super]
			and FixedRound(player.speed) >= 50*FRACUNIT
				if player.mo.state == S_PLAY_RUN
				and P_IsPlayerOnGround(player)
				and player.peeloutanim
					player.mo.state = S_PLAY_DASH
				end
				if player.speedeffect
					coolspeedwindlines(player)
					coollookindust(player)
				end
			elseif not player.powers[pw_underwater]
			and not player.powers[pw_super]
			and FixedRound(player.speed) < 60*FRACUNIT
			and player.mo.state == S_PLAY_DASH
			and not player.peelouting
			or not player.powers[pw_underwater]
			and player.powers[pw_super]
			and FixedRound(player.speed) < 90*FRACUNIT
			and player.mo.state == S_PLAY_DASH
			and not player.peelouting
			or player.powers[pw_underwater]
			and not player.powers[pw_super]
			and FixedRound(player.speed) < 30*FRACUNIT
			and player.mo.state == S_PLAY_DASH
			and not player.peelouting
			or player.powers[pw_underwater]
			and player.powers[pw_super]
			and FixedRound(player.speed) < 50*FRACUNIT
			and player.mo.state == S_PLAY_DASH
			and not player.peelouting
				if player.peeloutanim
				and player.mo.state == S_PLAY_DASH
				and P_IsPlayerOnGround(player)
					player.mo.state = S_PLAY_RUN
				end
			end
			if player.waterrun
				if player.mo.state == S_PLAY_DASH
					player.charflags = $|SF_RUNONWATER
				else
					player.charflags = $ & ~SF_RUNONWATER
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.stretch
			thicc(player)
		end
	end
end)

--water spash code and sprites re-used from junio sonic, freeslot is from chrispychars

local function CheckSlot(item) // this function deliberately errors when a freeslot does not exist
	if _G[item] == nil // this will error by itself for states and objects
		error() // this forces an error for sprites, which do actually return nil for some reason
	end
end

local function SafeFreeslot(...)
	local item = ...
	if item == nil
		return
	end
	
	if pcall(CheckSlot, item)
		print("\131NOTICE:\128 " .. item .. " was not allocated, as it already exists.")
	else
		freeslot(item)
	end
	
	SafeFreeslot(select(2, ...))
end

SafeFreeslot("SPR_AIDU", "S_KICKDUST")

states[S_KICKDUST] = {
	sprite = SPR_AIDU,
	frame = FF_ANIMATE | FF_PAPERSPRITE,
	var1 = 5,
	var2 = 1,
	tics = 10
}


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and P_IsPlayerManiafied(player)
		local mo = player.mo
		if player.waterruneffect
			if (player.charflags & SF_RUNONWATER) and leveltime % 3 == 0 and P_IsObjectOnGround(player.mo) and mo.eflags & MFE_TOUCHWATER and player.speed > skins[player.mo.skin].normalspeed
			and not (P_PlayerTouchingSectorSpecial(player, 1, 3))
				for i = -1, 1, 2
					local ang = i * ANG10
					local factor = FixedMul(4*mo.scale, cos(ang))
					local x = P_ReturnThrustX(mo, player.drawangle + ANGLE_180 + ang, 24*mo.scale)
					local y = P_ReturnThrustY(mo, player.drawangle + ANGLE_180 + ang, 24*mo.scale)
					local dust = P_SpawnMobjFromMobj(mo, x, y, 0, MT_THOK)
					dust.scale = 2*$/3
					dust.angle = R_PointToAngle2(dust.x, dust.y, mo.x, mo.y)
					dust.state = S_KICKDUST
					dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_90))
					dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_90))
				end
			end
		end
	end
end)

// Apparently running has a speed cap in Sonic 1 and 3

addHook("PlayerThink", function(player)
	if P_IsPlayerManiafied(player)
		if player.speedcap
		and P_IsPlayerOnGround(player)
		and not (player.pflags & PF_SPINNING)
		and player.speed > 280*FRACUNIT
			P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), -FRACUNIT)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and P_IsPlayerManiafied(player)
	and not player.airwalk
		if not P_IsObjectOnGround(player.mo)
		and (player.mo.state == S_PLAY_WALK
		or player.mo.state == S_PLAY_RUN
		or player.mo.state == S_PLAY_STND)
		and not player.powers[pw_carry]
		and player.playerstate == PST_LIVE
			if player.mo.momz > 5*FRACUNIT
				player.mo.state = S_PLAY_SPRING
			elseif player.mo.momz < 0
				player.mo.state = S_PLAY_FALL
			else
				player.mo.state = S_PLAY_ROLL
			end
		end
	end
end)