addHook("AbilitySpecial", function(player) //Jump check
	if player.mo.skin ~= "sonic" return end //Skin check
	if player.candropdash ~= true return end //Dropdash capability check
	if player.dpspin == true return end //Is the dropdash on spin?
	if (player.cmd.buttons & BT_JUMP) //Is player holding jump?
	and not P_IsPlayerOnGround(player) //Is player on ground?
	and not player.dropdash //Is the player dropdashing?
	and not (player.pflags & PF_THOKKED //Has the player used their ability?
	and (player.pflags & PF_JUMPED)) //Has the player jumped?
		player.dropdash = true //Set dropdash to true
		if player.dodpanim //If the dropdash animation is on...
			player.dpanim = 16 //Start it
		else //if it's off...
			player.dpanim = 0 //Dont start it
		end
		S_StartSound(player.mo, sfx_dpds) //Start dropdash sfx
		if player.dpanim //If dropdash anim on...
			player.mo.state = S_PLAY_SPRING //Set the state to spring
		else // If it's off...
			player.mo.state = S_PLAY_ROLL //Dont start it
		end
		return true //Make this the player's default ability if all checks return true
	elseif not player.candropdash // Can the player not dropdash?
	or player.dpspin == true
	and player.movestack == true
		return false // They can use the thok!
	end
end) //End the hook

addHook("SpinSpecial", function(player) //Spin check
	if player.mo.skin ~= "sonic" return end //Skin check
	if player.candropdash ~= true return end //Dropdash capability check
	if player.dpspin == false return end //Is the dropdash not on spin?
	if (player.cmd.buttons & BT_USE) //Is player holding spin
	and not P_IsPlayerOnGround(player) //Is player on ground?
	and not player.dropdash //Is the player dropdashing?
	and not (player.pflags & PF_THOKKED) //Has the player used their ability?
	and (player.pflags & PF_JUMPED) //Has the player jumped?
	and not player.powers[pw_shield] //Shield ability?
		player.dropdash = true //Set dropdash to true
		if player.dodpanim //If the dropdash animation is on...
			player.dpanim = 16 //Start it
		else //if it's off...
			player.dpanim = 0 //Dont start it
		end
		S_StartSound(player.mo, sfx_dpds) //Start dropdash sfx
		if player.dpanim //If dropdash anim on...
			player.mo.state = S_PLAY_SPRING //Set the state to spring
		else // If it's off...
			player.mo.state = S_PLAY_ROLL //Dont start it
		end
		return true //Make this the player's default ability if all checks return true
	end
end) //End the hook

addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "sonic" return end
	if player.candropdash ~= true return end
	if player.dpspin == true
		return true
	end
end)

addHook("PostThinkFrame", function() //We gonna be needing this to check for stuff after everything's happened
	for player in players.iterate() //Go through all players
		if player.mo and player.mo.valid
			if player.mo.skin ~= "sonic" continue end //Skin check //Imma leave you alone now
			if player.candropdash == nil
				player.candropdash = true
			end
			if player.dpspin == nil
				player.dpspin = false
			end
			if player.dodpanim == nil
				player.dodpanim = false
			end
			if player.insta == nil
				player.insta = false
			end
			if player.instas == nil
				player.instas = false
			end
			if player.dpsquake == nil
				player.dpsquake = false
			end
			if player.dropdash == nil
				player.dropdash = false
			end
			if player.dpanim == nil
				player.dpanim = 0
			end
			if player.dpanim > 0
				player.dpanim = $ - 1
			end
			// Dropdash
			if P_IsPlayerOnGround(player)
			and player.dpanim > 0
				player.dpanim = 0
			end
			if player.dropdash
				if player.dpanim
					if player.dpanim > 8
						player.mo.state = S_PLAY_SPRING
					elseif player.dpanim > 4 and player.dpanim < 8
						player.mo.state = S_PLAY_FALL
					elseif player.dpanim <= 4
						player.mo.state = S_PLAY_ROLL
					end
				else
					player.mo.state = S_PLAY_ROLL
				end
			end
			if (P_PlayerInPain(player)
			or P_IsPlayerOnGround(player)
			or player.playerstate == PST_DEAD
			or (player.mo.eflags & MFE_SPRUNG)
			or not (player.dpspin == false and (player.cmd.buttons & BT_JUMP) or player.dpspin == true and (player.cmd.buttons & BT_USE)))
			and player.dropdash
				player.dropdash = false
				player.dpanim = 0
				if P_IsPlayerOnGround(player)
				and not P_PlayerInPain(player)
				and player.playerstate ~= PST_DEAD
					if not player.powers[pw_sneakers]
						if not player.powers[pw_underwater]
							if not player.powers[pw_super]
								P_InstaThrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed + 15*FRACUNIT))
							else
								P_InstaThrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed + 25*FRACUNIT))
							end
						else
							P_InstaThrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed/2) + 5*FRACUNIT)
						end
					else
						if not player.powers[pw_underwater]
							P_InstaThrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed + 25*FRACUNIT))
						else
							P_InstaThrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed/2) + 5*FRACUNIT)
						end
					end
					S_StartSound(player.mo, sfx_zoom)
					player.pflags = $|PF_SPINNING
					player.mo.state = S_PLAY_ROLL
					if player.dpsquake
					and player.powers[pw_super]
						P_StartQuake(45*FRACUNIT, TICRATE/2)
					end
				end
			end
		end
	end
end)

// Adding this in right before I publish it

addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "sonic" return end
	if player.candropdash == false
	or player.dpspin == true
	and player.movestack == true
		return false
	end
end)